package com.chinaitop.depot.pushs.service.impl;

import java.text.SimpleDateFormat;
import java.util.*;

import javax.annotation.Resource;

import com.alibaba.fastjson.JSONArray;
import com.chinaitop.depot.storage.mapper.StorageQualitycheckMapper;
import com.chinaitop.depot.storage.model.StorageQualitycheck;
import com.chinaitop.depot.storage.model.StorageQualitycheckExample;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.alibaba.fastjson.JSON;
import com.chinaitop.depot.pushs.service.PushscheckService;
import com.chinaitop.depot.unissoft.model.ResponseEntity;

@Service
public class PushcheckServiceImpl implements PushscheckService {

	final static Logger logger  =  LoggerFactory.getLogger(PushcheckServiceImpl.class );


	@Resource
	private StorageQualitycheckMapper qualitycheckMapper;

	@Transactional(rollbackFor = Exception.class)
	@Override
	public String downFcInfo(String orgId,String cfId,String hwId) {//
		Map<String,Object> mapData = new HashMap<String, Object>();
		try{
			StorageQualitycheck check = new StorageQualitycheck();
			check.setOrgId(Integer.valueOf(orgId));
			check.setHouseId(Integer.valueOf(cfId));
			check.setWarehouseId(Integer.valueOf(hwId));
			List<StorageQualitycheck> checkList =qualitycheckMapper.selectfc(check);
			SimpleDateFormat date = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
			String datetime = date.format(checkList.get(0).getSealDate());
			String fcNumber = checkList.get(0).getNumber();
			mapData.put("success", "true");
			mapData.put("fctime", datetime);
			mapData.put("fcNumber", fcNumber);
			return JSON.toJSONString(ResponseEntity.ok(mapData));
		}catch (NumberFormatException e) {
			logger.info("未查询到结果");
			e.printStackTrace();
			mapData.put("success", "false");
			mapData.put("msg", "根据该条件，未查询到结果");
		} finally {
			JSONArray jsonArray = new JSONArray();
			if (mapData.size()==0) {
				mapData.put("success", "false");
				mapData.put("msg", "根据该条件，未查询到结果");
			}
			jsonArray.add(mapData);
			return jsonArray.toString();
		}


	}


}