package com.chinaitop.depot.storage.service.impl;

import java.util.ArrayList;
import java.util.List;

import javax.annotation.Resource;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.chinaitop.depot.storage.mapper.BusinessFileMapper;
import com.chinaitop.depot.storage.mapper.StorageChangeStoragehouseTaskMapper;
import com.chinaitop.depot.storage.model.BusinessFile;
import com.chinaitop.depot.storage.model.BusinessFileExample;
import com.chinaitop.depot.storage.model.BusinessFileExample.Criteria;
import com.chinaitop.depot.storage.model.StorageChangeStoragehouseTask;
import com.chinaitop.depot.storage.model.StorageChangeStoragehouseTaskExample;
import com.chinaitop.depot.storage.service.StorageChangeStoragehouseTaskService;
@Service
public class StorageChangeStoragehouseTaskServiceImpl implements StorageChangeStoragehouseTaskService {

	@Resource 
	private StorageChangeStoragehouseTaskMapper storageChangeStoragehouseTaskMapper;
	
	@Autowired
    private BusinessFileMapper fileMapper;
	/**
	 * 查询倒仓主表数据
	 */
	@Override
	public List<StorageChangeStoragehouseTask> selectByExample(StorageChangeStoragehouseTaskExample example) {
		return storageChangeStoragehouseTaskMapper.selectByExample(example);
	}
	/**
	 * 新增倒仓数据
	 */
	@Override
	public void addStorageChangeStoragehouseTask(StorageChangeStoragehouseTask storageChangeStoragehouseTask) {
		storageChangeStoragehouseTaskMapper.insertSelective(storageChangeStoragehouseTask);
	}
	/**
	 * 修改倒仓数据
	 */
	@Override
	public void updateStorageChangeStoragehouseTask(StorageChangeStoragehouseTask storageChangeStoragehouseTask) {
		storageChangeStoragehouseTaskMapper.updateByPrimaryKey(storageChangeStoragehouseTask);
		
	}
	/**
	 * 删除一条倒仓数据
	 */
	@Override
	public void removeChangeData(StorageChangeStoragehouseTaskExample example) {
		storageChangeStoragehouseTaskMapper.deleteByExample(example);
		
	}
	@Override
	public void updateDcStatus(StorageChangeStoragehouseTask storageChangeIsUpload) {
		storageChangeStoragehouseTaskMapper.updateByPrimaryKeySelective(storageChangeIsUpload);
	}
	/**
	 * 添加文件到business_file
	 */
	@Override
	public void updateFileByFileIdsAndBid(String fileIds, Integer storageId, String fileType) {
		 if (StringUtils.isNotBlank(fileIds) && !"[]".equals(fileIds)) {
	            BusinessFile businessFile = new BusinessFile();
	            businessFile.setBid(storageId);
	            
	            BusinessFileExample example = new BusinessFileExample();
	            Criteria createCriteria = example.createCriteria();
	            // 去除开头结尾.
	            fileIds = fileIds.substring(1, fileIds.length());
	            fileIds = fileIds.substring(0, fileIds.length() - 1);
	            String[] idArray = fileIds.split(",");
	            List<Integer> idList = new ArrayList<Integer>();
	            for (String id : idArray) {
	                idList.add(Integer.parseInt(id));
	            }
	            
	            createCriteria.andIdIn(idList);
	            createCriteria.andTypeEqualTo(fileType);
	            fileMapper.updateByExampleSelective(businessFile, example);
        }
	}
	@Override
	public List<BusinessFile> getByBid(Integer bid, String fileType, Integer orgId, String order) {
		BusinessFileExample example = new BusinessFileExample();
        Criteria criteria = example.createCriteria();
        
    		if (null != fileType) {
        		criteria.andTypeEqualTo(fileType);
        	}
        	if (null != bid) {
        		criteria.andBidEqualTo(bid);
        	}
        	if (null != orgId) {
        		criteria.andOrgIdEqualTo(orgId);
        	}
        	if (null != order && !"".equals(order)) {
        		example.setOrderByClause(order);
        	}
        
        	return fileMapper.selectByExample(example);
	}

}
