package com.chinaitop.depot.storage.service.impl;

import com.chinaitop.depot.storage.mapper.StorageQualitycheckMapper;
import com.chinaitop.depot.storage.mapper.StorageQualitycheckSonMapper;
import com.chinaitop.depot.storage.model.StorageQualitycheck;
import com.chinaitop.depot.storage.model.StorageQualitycheckExample;
import com.chinaitop.depot.storage.model.StorageQualitycheckSon;
import com.chinaitop.depot.storage.model.StorageQualitycheckSonExample;
import com.chinaitop.depot.storage.service.StorageQualitycheckService;
import com.chinaitop.depot.storage.service.StorageQualitycheckSonService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class StorageQualitycheckServiceImpl implements StorageQualitycheckService {

	@Resource
	private StorageQualitycheckMapper qualitycheckMapper;
	@Resource
	private StorageQualitycheckSonMapper storageQualitycheckSonMapper;
    @Resource
    private StorageQualitycheckSonService qualitycheckSonService;



    @Override
	public List<StorageQualitycheck> queryByQualitycheck(StorageQualitycheck example) {
		//对list进行处理获取仓房名称和货位名称
		return qualitycheckMapper.queryByExample(example);
	}

	@Override
	public List<StorageQualitycheck> queryByQualitychecklist(StorageQualitycheck example) {
		//对list进行处理获取仓房名称和货位名称
		return qualitycheckMapper.queryByExamplelist(example);
	}

	// 保存数据
	@Override
	public Integer save(StorageQualitycheck qualitycheck) {
        Integer qualityCheckId=0;
		if (qualitycheck.getId() == null) {
			qualitycheckMapper.insertSelective(qualitycheck);// 新增数据
            //如果验收，把页面验收隐藏
            if("1".equals(qualitycheck.getType())){
                qualitycheckMapper.updateByFlagType(qualitycheck);
            }
            qualityCheckId = qualitycheck.getId();
        } else {
            qualitycheckMapper.updateByPrimaryKeySelective(qualitycheck);// 修改数据
            qualityCheckId = qualitycheck.getId();
		}
		return qualityCheckId;
	}

	// 保存字表数据
	@Override
	public void saveOne(StorageQualitycheckSon qualitycheckone) {
	    if(qualitycheckone.getId() == null){
            storageQualitycheckSonMapper.insertSelective(qualitycheckone);// 新增数据
        } else {
            storageQualitycheckSonMapper.updateByPrimaryKeySelective(qualitycheckone);//修改数据
        }
	}

	@Override
	public void remove(int id) {
		// 删除数据
		qualitycheckMapper.deleteByPrimaryKey(id);
	}

	/**
	 * 根据条件获得第三方检查列表
	 * @param qualitycheck
	 * @return
	 */
	@Override
	public List<StorageQualitycheck> getThirdCheckList(StorageQualitycheck qualitycheck) {
		return  qualitycheckMapper.getThirdCheckList(qualitycheck);
	}

	@Override
	public List<StorageQualitycheck> getQualitycheckListByFoodbasicinfoCheck(StorageQualitycheck qualitycheck,Integer foodbasicinfoId) {

        List<StorageQualitycheck> list = qualitycheckMapper.getQualitycheckListByFoodbasicinfoCheck(qualitycheck);

//        if(list.size()>0){
//            int i = 0;
//            for(;i<list.size();i++){
//                List<StorageQualitycheckSon> QualitycheckdList =  qualitycheckSonService.selectByQualitycheckId(list.get(i).getId());
//                for(StorageQualitycheckSon qc : QualitycheckdList){
//                    if(qc.getNumbering()== 2791 ){
//                        list.get(i).setWater(qc.getSetValue());
//                        continue;
//                    }
//                    if(qc.getNumbering() == 2790 ){
//                        list.get(i).setGlutenWaterCount(qc.getSetValue());
//                        continue;
//                    }
//                    if(qc.getNumbering() == 2798 ){
//                        list.get(i).setFatIndex(qc.getSetValue());
//                        continue;
//                    }
//                    if(qc.getNumbering() == 2797 ){
//                        list.get(i).setEatScore(qc.getSetValue());
//                        continue;
//                    }
//                    if(qc.getNumbering() == 2796 ){
//                        list.get(i).setColorsmell(qc.getSetValue());
//                        continue;
//                    }
//                    if(qc.getNumbering() == 2795 ){
//                        list.get(i).setMildewCount(qc.getSetValue());
//                        continue;
//                    }
//                }
//            }
//        }
		return list;
	}

	@Override
	public Map<String, Object> loadDataById(Integer id) {
        StorageQualitycheck qualitycheck = null;
        Map<String,Object> retMap = new HashMap<String,Object>();

        if(id!=null){
            qualitycheck=qualitycheckMapper.queryPrimaryKey(id);
            //带出子表的数据（过氧化值，脂肪酸值(酸价)）
            StorageQualitycheckSonExample storageQualitycheckSonExample = new StorageQualitycheckSonExample();
            StorageQualitycheckSonExample.Criteria criteria = storageQualitycheckSonExample.createCriteria();
            criteria.andQualitycheckIdEqualTo(id);
            //List<StorageQualitycheckSon> qualitycheckSonList = qualitycheckSonService.findQualitycheckSonExample(storageQualitycheckSonExample);
            Map<String, Object> qualitycheckSon = qualitycheckSonService.findQualitycheckSon(id);
            retMap.put("qualitycheck",qualitycheck);
            retMap.put("qualitycheckSon",qualitycheckSon);
//            for(StorageQualitycheckSon sqk : qualitycheckSonList){
//                if(sqk.getNumbering()== 6996 ){
//                    qualitycheck.setFatIndex(sqk.getSetValue());
//                    continue;
//                }
//                if(sqk.getNumbering() == 6995 ){
//                    qualitycheck.setPeroxideValue(sqk.getSetValue());
//                    continue;
//                }
//                if(sqk.getNumbering()== 2789 ){//品尝评分
//                    qualitycheck.setEatScore(sqk.getSetValue());
//                    continue;
//                }
//                if(sqk.getNumbering()== 2797 ){//品尝评分
//                    qualitycheck.setEatScore(sqk.getSetValue());
//                    continue;
//                }
//                if(sqk.getNumbering() == 2790 ){//面筋吸水量(%)
//                    qualitycheck.setGlutenWaterCount(sqk.getSetValue());
//                    continue;
//                }
//                if(sqk.getNumbering() == 2798 ){//脂肪酸值
//                    qualitycheck.setFatIndex(sqk.getSetValue());
//                    continue;
//                }
//                if(sqk.getNumbering() == 2788 ){//色泽气味
//                    qualitycheck.setColorsmell(sqk.getSetValue());
//                    continue;
//                }
//                if(sqk.getNumbering() == 2796 ){//色泽气味
//                    qualitycheck.setColorsmell(sqk.getSetValue());
//                    continue;
//                }
//                if(sqk.getNumbering() == 2795 ){//霉变粒
//                    qualitycheck.setMildewCount(sqk.getSetValue());
//                    continue;
//                }
//                if(sqk.getNumbering() == 2801 ){//容重(出糙率%或纯粮率%)
//                    qualitycheck.setCapacity(sqk.getSetValue());
//                    continue;
//                }
//                if(sqk.getNumbering() == 2802 ){//不完善粒(整精米率%)：
//                    qualitycheck.setBadpart(sqk.getSetValue());
//                    continue;
//                }
//            }
        }
        return retMap;
	}

    @Override
    public String getQualityStandardStr(Integer id) {
        String returnStr = "";
        StringBuffer sb = new StringBuffer();
        StorageQualitycheck qc = qualitycheckMapper.selectByPrimaryKey(id);
        if (qc != null) {
            // 品种.
            Integer subType = qc.getSubType();
            if (subType == 3164) {
                // 小麦.
                if (StringUtils.isNotBlank(qc.getCapacity())) {
                    sb.append("容重").append(qc.getCapacity()).append("g/L;");
                }
                if (StringUtils.isNotBlank(qc.getBadpart())) {
                    sb.append("不完善粒含量").append(qc.getBadpart()).append("%;");
                }

            } else if (subType == 3165) {
                // 玉米.
                if (StringUtils.isNotBlank(qc.getCapacity())) {
                    sb.append("容重").append(qc.getCapacity()).append("g/L;");
                }
                if (StringUtils.isNotBlank(qc.getBadpart())) {
                    sb.append("不完善粒含量总计").append(qc.getBadpart()).append("%;");
                }
                if (StringUtils.isNotBlank(qc.getMildewCount())) {
                    sb.append("其中：生霉粒").append(qc.getMildewCount()).append("%;");
                }
            } else if (subType == 3166) {
                // 稻谷.
                if (StringUtils.isNotBlank(qc.getHuskedRation())) {
                    sb.append("出糙率").append(qc.getMildewCount()).append("%;");
                }
                if (StringUtils.isNotBlank(qc.getFullGoodRation())) {
                    sb.append("整精米率").append(qc.getFullGoodRation()).append("%;");
                }
                if (StringUtils.isNotBlank(qc.getYellowPart())) {
                    sb.append("黄粒米").append(qc.getYellowPart()).append("%;");
                }
                if (StringUtils.isNotBlank(qc.getOutHuskedRation())) {
                    sb.append("谷外糙米").append(qc.getOutHuskedRation()).append("%;");
                }
            } else if (subType == 2777) {
                // 大豆.
                if (StringUtils.isNotBlank(qc.getGoodpart())) {
                    sb.append("完整粒率").append(qc.getGoodpart()).append("%;");
                }
                if (StringUtils.isNotBlank(qc.getDamageRatio())) {
                    sb.append("损伤粒率").append(qc.getDamageRatio()).append("%;");
                }
                if (StringUtils.isNotBlank(qc.getHotDamageRatio())) {
                    sb.append("其中：热损伤粒").append(qc.getHotDamageRatio()).append("%;");
                }
            }

            if (StringUtils.isNotBlank(qc.getImpurity())) {
                sb.append("杂质").append(qc.getImpurity()).append("%;");
            }
            if (StringUtils.isNotBlank(qc.getWater())) {
                sb.append("水分").append(qc.getWater()).append("%;");
            }
            if (StringUtils.isNotBlank(qc.getColorsmell())) {
                sb.append("色泽气味").append(qc.getColorsmell()).append(";");
            }
            returnStr = sb.toString();
        }
        return returnStr;
    }

    @Override
    public List<StorageQualitycheck> getHouseOrWareList(
            StorageQualitycheck qualitycheck) {
        List<StorageQualitycheck> list = null;
        //5：第三方检查
        qualitycheck.setType("5");

        // 仓房id.
        if (qualitycheck.getHouseId() != null) {
            list = qualitycheckMapper.getWareHouseIdList(qualitycheck);
        } else {
            list = qualitycheckMapper.getHouseIdList(qualitycheck);
        }
        return list;
    }

    /**
     * 更新质量管理为历史数据
     * @param houseId
     * @return
     */
    @Override
    public void setQualityCheckByHistoryStatus(Integer houseId,Integer warehouseId) {

        StorageQualitycheck qualitycheck = new StorageQualitycheck();
        //0:最新数据  1:历史数据
        qualitycheck.setHistoryStatus(1);

        StorageQualitycheckExample qualityCheckExample = new StorageQualitycheckExample();
        StorageQualitycheckExample.Criteria qualityCriteria = qualityCheckExample.createCriteria();
        if(houseId != null){
            qualityCriteria.andHouseIdEqualTo(houseId);
        }
        if(warehouseId != null){
            qualityCriteria.andWarehouseIdEqualTo(warehouseId);
        }

        //更新质量管理状态为历史数据
        qualitycheckMapper.updateByExampleSelective(qualitycheck,qualityCheckExample);

    }

    @Override
    public List<Map<String,Object>> getStoreQualityList(Integer orgId) {
        return qualitycheckMapper.getStoreQualityList(orgId);
    }
    

	@Override
	public List<Map<String,Object>> getTrdStoreQualityList() {
		// TODO Auto-generated method stub
		return qualitycheckMapper.getTrdStoreQualityList();
	}

	@Override
	public List<Map<String,Object>> getQualityListUs() {
		// TODO Auto-generated method stub
		return qualitycheckMapper.getQualityListUs();
	}


    /**
     * 新增验收数据
     * @throws Exception
     */
    @Override
    @Transactional(readOnly = false)
    public List<StorageQualitycheck> getDataByZJId(Map<String, Object> paramMap) {
        return qualitycheckMapper.getDataByZJId(paramMap);
    }

    @Override
    public List<StorageQualitycheck> queryByQualitycheckData(StorageQualitycheck example) {

        return qualitycheckMapper.queryByExampleData(example);
    }

    @Override
    public List<StorageQualitycheck> queryByQualitycheckusiness(StorageQualitycheck qualityCheckExample) {

        return qualitycheckMapper.queryByQualitycheckusiness(qualityCheckExample);
    }

    @Override
    public List<Map<String,Object>>getAllQualityMain(Map<String, Object> paramMap) {
        return qualitycheckMapper.getAllQualityMain(paramMap);
    }

    @Override
    public List<Map<String, Object>> getAllQualityInfo(Map<String, Object> paramMap) {
        return qualitycheckMapper.getAllQualityInfo(paramMap);
    }

    @Override
    public List<Map<String, Object>> getAllFoodStocks(Map<String, Object> paramMap) {
        return qualitycheckMapper.getAllFoodStocks(paramMap);
    }

    @Override
	public List<StorageQualitycheck> findByCondition(StorageQualitycheckExample example) {
		return qualitycheckMapper.selectByExample(example);
	}
}